"""
Good Bad Attitude
by Javantea
May 26, 2006

Get a list of pids, then recheck and kill all new pids.
This is part of a system of attack/reattack/etc.

TODO:
Ensure that we don't kill good procs.
We currently kill ps. That's not a big bug, but it is a bug. 
It's better to kill something not there than to let someone go crazy.
"""

import os
import time

def ps_pids(prog_names = False):
	"""
	Get a list of current process ids.
	"""
	ps = os.popen("ps -A")
	data = ps.read()
	
	# Initial setup.
	ps_pids = []
	for prog in data.split("\n"):
		field = prog.split()
		if len(field) <= 0: continue
		if field[0] == 'PID': continue
		pid = field[0]
		tty = field[1]
		time = field[2]
		program = field[3]
		if prog_names: print pid, program
		ps_pids.append(pid)
	#next c
	return ps_pids
#end def ps_pids()

def main():
	"""
	The attack.
	"""
	# Initial setup.
	# Get a list of pids currently running. They will not be killed.
	print 'Good list:'
	good_pids = ps_pids(True)
	
	# Remove all new pids.
	while True:
		# get a new list of pids from ps -A
		new_pids = ps_pids()
		for pid in new_pids:
			if pid not in good_pids:
				# kill the pid!
				print 'killing', pid
				os.system('kill ' + str(pid))
			#end if
		#next pid
		try:
			time.sleep(1)
		except KeyboardInterrupt:
			break
		#end try
	#loop
#end def main()

if __name__ == '__main__':
	main()
#end if
